using System;
using System.Collections.Generic;
using System.Text;
using DBAccess.EAI;
using System.Data;
using System.IO;
using System.Collections;

namespace Control.STK
{
    public class ClsDataQueryControl:ClsGoodsOPControl
    {




        //ClsCOMMonitorControl objMonitorControl = new ClsCOMMonitorControl();

        public DataTable getRecordCount()
        {
            string strSql = "select nOrginType,count(*) as qty,iif(isnull(sum(nAmount)),0,sum(nAmount)) as Amount   from ScanInfo group by nOrginType order by nOrginType";
            return ClsGlobal.objTempDataConnect.DataQuery(strSql);
        }

        //public DataTable getTypeBarcordCount(byte ntype, string barcode)
        //{
        //    string strtemp;
        //    string strSql = "select count(*) as qty,sum(nAmount) as Amount from ScanInfo where 1=1 ";
        //    if (ntype > 0)
        //    {
        //        strtemp = objMonitorControl.gettypename(ntype);
        //        strSql += "and ntype=" + ClsCommon.GetSqlString(strtemp);
        //    }
        //    if (barcode.Length > 0)
        //        strSql += "and cbarcode=" + ClsCommon.GetSqlString(barcode);
        //    return ClsGlobal.objTempDataConnect.DataQuery(strSql);
        //}

        public DataTable getconBarcordCount(byte ntype, string barcode,string starttime,string endtime,string selfID,string lotNo)
        {
            //string strtemp;
            string strSql = "select count(*) as qty,iif(isnull(sum(nAmount)),0,sum(nAmount)) as Amount from ScanInfo where 1=1 ";


            if (ntype >= 0 && ntype < 255)
            {
               // byte ntype = (byte)((int)ntype1 + 1);
                //strtemp = objMonitorControl.gettypename(ntype);
                strSql += "and nOrginType=" + ClsCommon.GetSqlString(ntype);
            }
            if (barcode.Length > 0)
                strSql += "and cbarcode=" + ClsCommon.GetSqlString(barcode);
            if (selfID.Length > 0)
                strSql += "and cSelfID=" + ClsCommon.GetSqlString(selfID);
            if (lotNo.Length > 0)
                strSql += "and cBatch=" + ClsCommon.GetSqlString(lotNo);
            if (starttime.Length > 0)
                strSql += "and cOPTime>=" + ClsCommon.GetSqlString(starttime);
            if (starttime.Length > 0)
                strSql += "and cOPTime<=" + ClsCommon.GetSqlString(endtime);
            return ClsGlobal.objTempDataConnect.DataQuery(strSql);
        }

        public int getRecordChar(byte[] data,int start)
        {
            DataTable dt = getRecordCount();
            int col = start;
            string strtemp;
            int qty = 0;
            DataRow[] selectrows;
            byte ntype;
            for (int i = 0; i < 5; i++)
            {
                //ntype = (byte)i;
                //strtemp = objMonitorControl.gettypename(ntype);
                selectrows = dt.Select("nOrginType=" + i );
                qty = 0;
                if (selectrows.Length > 0)
                {
                    qty = int.Parse(selectrows[0]["qty"].ToString());
                }
              //  qty = qty * 100;
                data[col] =(byte) (qty / (256 * 256 * 256));
                data[col+1] = (byte)(qty / (256 * 256 ));
                data[col+2] = (byte)(qty / 256);
                data[col+3] = (byte)(qty % 256 );
                col += 4;

                //qty = 0;
                //if (selectrows.Length > 0)
                //{
                //    qty = uint.Parse(selectrows[0]["Amount"].ToString());
                //}

                //data[col] = (byte)(qty / (256 * 256 * 256));
                //data[col + 1] = (byte)(qty / (256 * 256));
                //data[col + 2] = (byte)(qty / 256);
                //data[col + 3] = (byte)(qty % 256);
                //col += 4;
            }
            return col;           
            
        }

        public int getTypeRecordChar(byte[] data, int start, byte ntype, string barcode, string starttime, string endtime, string selfID, string lotNo)
        {
            DataTable dt = getconBarcordCount(ntype, barcode, starttime, endtime, selfID, lotNo);
            int col = start;

            double qty = 0;
            int tempqty;
            byte[] tempvalues;

            for (int i = 0; i < 2; i++)
            {

                qty = 0;
                if (dt != null && dt.Rows.Count > 0)
                {
                    if (dt.Rows[0][i] != null && dt.Rows[0][i].ToString().Length > 0)
                    {
                        string temp = dt.Rows[0][i].ToString();
                        qty = double.Parse(temp);
                    }
                    if (1 == i)
                        qty = qty * 100;
                }

                tempqty = Convert.ToInt32(qty);
                tempvalues = BitConverter.GetBytes(tempqty);
                /*   byte ch = 0x00;

                
                   if (qty < 0)
                       ch = 0x80;
                 //  qty = Math.Abs(qty);
                 //  data[col ] ^= ch;
                 //  qty = qty >> 8;
                   data[col] = (byte)(qty / (256 * 256 * 256));
                   data[col + 1] = (byte)(qty / (256 * 256));
                   data[col + 2] = (byte)(qty / 256);
                   data[col + 3] = (byte)(qty % 256);
                    * */
                //   for (int j = 0; j < 4; j++)
                //     data[col + j] ^=  ch;
                data[col] = tempvalues[3];
                data[col + 1] = tempvalues[2];
                data[col + 2] = tempvalues[1];
                data[col + 3] = tempvalues[0];
                //for (int j = 0; j < 4; j++)
                //   data[col + j] = tempvalues[j];
                col += 4;
            }
            return col;

        }

        public DataTable getBillNos()
        {
            string strSql = "select BillNo   from Bill order by BillNo";

            return ClsGlobal.objTempDataConnect.DataQuery(strSql);
            

        }

        public int getBillNoChar(byte[] data, int start)
        {
            int len = 8;
            int col = start;
          
            
            data[start] = (byte)0;
            col++;

            byte[] tempvalues;
            string bill = string.Empty;
            DataTable dt = getBillNos();
            if (dt != null && dt.Rows.Count > 0)
            {
                foreach (DataRow row in dt.Rows)
                {
                    bill = ClsBitDataControl.FillString(row[0].ToString().Trim(), len);

                    tempvalues = Encoding.Default.GetBytes(bill);
                    for (int i = 0; i < tempvalues.Length; i++)
                    {
                        data[col + i] = tempvalues[i];
                    }
                    col += tempvalues.Length;
                }
                data[start] = (byte)(dt.Rows.Count*len);
            }


            return col;
        }

        public string getBillNoStrs()
        {
            int len=8;
            string bills = string.Empty;
            DataTable dt = getBillNos();
            if (dt != null && dt.Rows.Count > 0)
            {
                foreach (DataRow row in dt.Rows)
                {
                    bills += ClsBitDataControl.FillString(row[0].ToString().Trim(), len);

                }                
            }
            
            
            return bills;
        }
       

        public string getBillNo()
        {


            DataTable dt = getBillNos();
            if (dt != null && dt.Rows.Count > 0)
            {
                return dt.Rows[0][0].ToString().Trim();
            }
            else            
                return "NULL";          

        }
       
        public int getGoodsInfo(bool isLocal,string barcode, string selfID, string lotNo, ref string strgoodname, ref  string strspec, ref  string strunit, ref  double stockqty, ref  double inprice, ref  double outprice)
        {

           // int  posgoodsname, posunit;

            //Double stockqty = 0, price = 0, price2 = 0;
           // byte[] tempvalues;
           // string strgoodname = string.Empty, strspec = string.Empty, strunit = string.Empty;
            //int qty;


            DataTable dt = null;
           if (isLocal)
            dt = getGoodsinfoData(barcode, selfID, lotNo);
           else
            dt = getDBGoodsinfoData(barcode, selfID, lotNo);
           
            if (dt != null && dt.Rows.Count > 0)
            {
                if (dt.Rows[0]["cgoodsname"] != null)
                {
                    strgoodname = dt.Rows[0]["cgoodsname"].ToString().Trim();
                }

                if (dt.Rows[0]["cspec"] != null)
                {
                    strspec = dt.Rows[0]["cspec"].ToString().Trim();
                }

                if (dt.Rows[0]["cunits"] != null)
                {
                    strunit = dt.Rows[0]["cunits"].ToString().Trim();
                }


                if (dt.Rows[0]["famount"] != null && dt.Rows[0]["famount"].ToString().Length > 0)
                {
                    //  string temp = dt.Rows[0][i].ToString();
                    stockqty = Double.Parse(dt.Rows[0]["famount"].ToString());
                    //stockqty = stockqty * 100;
                }


                //if (ntype == 0x01)
                //{
                //    if (dt.Rows[0]["foutprice_1"] != null && dt.Rows[0]["foutprice_1"].ToString().Length > 0)
                //    {
                //        //  string temp = dt.Rows[0][i].ToString();
                //        price = Double.Parse(dt.Rows[0]["foutprice_1"].ToString());
                //        price = price * 100;
                //    }
                //}
                //else
                //{
                //    if (dt.Rows[0]["finprice"] != null && dt.Rows[0]["finprice"].ToString().Length > 0)
                //    {
                //        //  string temp = dt.Rows[0][i].ToString();
                //        price = Double.Parse(dt.Rows[0]["finprice"].ToString());
                //        price = price * 100;
                //    }
                //}


                if (dt.Rows[0]["finprice"] != null && dt.Rows[0]["finprice"].ToString().Length > 0)
                {
                    //  string temp = dt.Rows[0][i].ToString();
                    inprice = Double.Parse(dt.Rows[0]["finprice"].ToString());
                   // price = price * 100;
                }

                if (dt.Rows[0]["foutprice_1"] != null && dt.Rows[0]["foutprice_1"].ToString().Length > 0)
                {
                    //  string temp = dt.Rows[0][i].ToString();
                    outprice = Double.Parse(dt.Rows[0]["foutprice_1"].ToString());
                   // price2 = price2 * 100;
                }


                return 0;
            }
            else
            {
                strgoodname = TOTA.Properties.Resources.rsQueryNotFind;// "(δҵ)";
                return -1;
            }

          

        }

      


       





       



       
    }




}
