using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Threading;
using DBAccess.EAI;

namespace Boundary.STK
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            CustomExceptionHandler eh = new CustomExceptionHandler();
            Application.ThreadException += new ThreadExceptionEventHandler(eh.OnThreadException);
            Application.Run(new frmMain());
        }

        internal class CustomExceptionHandler
        {
            public void OnThreadException(object sender, ThreadExceptionEventArgs t)
            {
                ClsGlobal.objErrorControl.WriteErrorLog("EU0001000",
                   "error log", t.Exception.Message, ClsGlobal.ConfigTypeName);
                
                //string aa = t.Exception.GetType().ReflectedType.Name;
                //switch (aa)
                //{
                //    case "DivideByZeroException":
                //        break;
                //    default :
                //        throw t.Exception;
                //        break;

                //}
                // MessageBox.Show(aa+"   " + t.Exception.Message);
                // throw t.Exception;
            }
        }

    }
}